﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Stimulsoft.Report;
using Stimulsoft.Base.Localization;

namespace StimulsoftReportDesigner
{
    public partial class MainPage : UserControl
    {
        StiReport report = new StiReport();
        public MainPage()
        {
            Stimulsoft.Report.StiOptions.Silverlight.WCFService.WCFRenderReport
                += new Stimulsoft.Report.Events.StiWCFEventHandlers(WCFService_WCFRenderReport);
            Stimulsoft.Report.StiOptions.Silverlight.WCFService.UseWCFService = true;

            InitializeComponent();
            //List<MyData> myData = new List<MyData>();
            //myData.Add(new MyData());
            //Stimulsoft.Report.Dictionary.StiBusinessObjectData dic = 
            //    new Stimulsoft.Report.Dictionary.StiBusinessObjectData("MyData", "MyData", new MyData());
            //List<Stimulsoft.Report.Dictionary.StiBusinessObjectData> data = new List<Stimulsoft.Report.Dictionary.StiBusinessObjectData>();
            //data.Add(dic);
            ////StiWebDesignerSL1.DataContext = myData;
            //Stimulsoft.Report.StiReport report = new Stimulsoft.Report.StiReport();
            //report.RegBusinessObject(data);
            //report.Show();
            GetReport2();
        }

        void WCFService_WCFRenderReport(object sender, Stimulsoft.Report.Events.StiWCFEventArgs e)
        {
            StiWebDesignerSL1.StartProgressInformation("WCF Service",
               StiLocalization.Get("DesignerFx", "CompilingReport"), System.Windows.Visibility.Visible, true);

            ServiceReference1.Service1Client service = new ServiceReference1.Service1Client();
            service.RenderReportCompleted
                += new EventHandler<ServiceReference1.RenderReportCompletedEventArgs>(service_RenderReportCompleted);
            service.RenderReportAsync(e.Xml);
        }

        void service_RenderReportCompleted(object sender, ServiceReference1.RenderReportCompletedEventArgs e)
        {
            if (e.Error == null && e.Result != null && e.Result.Length > 2)
            {
                StiWebDesignerSL1.ApplyRenderedReport(e.Result);
            }

            StiWebDesignerSL1.CloseProgressInformation();
            
        }

        private void GetReport2()
        {
            ServiceReference1.Service1Client obj = new ServiceReference1.Service1Client();
            obj.GetData2Completed += new EventHandler<ServiceReference1.GetData2CompletedEventArgs>(obj_GetData2Completed);
            obj.GetData2Async();
        }

        void obj_GetData2Completed(object sender, ServiceReference1.GetData2CompletedEventArgs e)
        {
            string reportDefXml = e.Result.ToString();

            report.LoadFromString(reportDefXml);
            //report.RegBusinessObject("NewName", "Test", e.Result);
            // report.Show();
            StiWebDesignerSL1.Report = report;
           // GetReportData2(report);
        }

       /* Below code - Not Used */
        private void GetReportData2(StiReport report)
        {
            ServiceReference1.Service1Client obj = new ServiceReference1.Service1Client();
            obj.GetListDataCompleted += new EventHandler<ServiceReference1.GetListDataCompletedEventArgs>(obj_GetListDataCompleted);
            obj.GetListDataAsync(report);
        }

        void obj_GetListDataCompleted(object sender, ServiceReference1.GetListDataCompletedEventArgs e)
        {
            StiReport report = (StiReport)e.UserState;
            
            report.RegBusinessObject("NewName", "Test", e.Result);
            // report.Show();
            //StiWebDesignerSL1.Report = report;
            //  GetData();
        }

        void obj_GetReportData2Completed(object sender, ServiceReference1.GetData2CompletedEventArgs e)
        {
            StiReport report = (StiReport)e.UserState;
            report.RegBusinessObject("NewName", "Test", e.Result);
            // report.Show();
            //StiWebDesignerSL1.Report = report;
            //  GetData();
        }


      
    }
}
